/*
 *  Copyright (C) 2012  Regents of the University of Michigan
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

//////////////////////////////////////////////////////////////////////////
// This file contains the processing for the executable option "trimBam"
// which trims the ends of reads in a SAM/BAM file changing read ends to 'N'
// and quality to '!'.

#ifndef __TRIM_BAM_H__
#define __TRIM_BAM_H__

#include "BamExecutable.h"

class TrimBam : public BamExecutable
{
public:
    static void trimBamDescription();
    void description();
    void usage();
    int execute(int argc, char **argv);
};

#endif
